package main

import "time"

type AllServices struct {
	AreServicesAvailable bool        `json:"areServicesAvailable"`
	BusServices          interface{} `json:"busServices"`
	Crs                  string      `json:"crs"`
	FerryServices        interface{} `json:"ferryServices"`
	Filtercrs            string      `json:"filtercrs"`
	FilterLocationName   string      `json:"filterLocationName"`
	FilterType           int         `json:"filterType"`
	GeneratedAt          time.Time   `json:"generatedAt"`
	LocationName         string      `json:"locationName"`
	NrccMessages         []struct {
		Value string `json:"value"`
	} `json:"nrccMessages"`
	PlatformAvailable bool `json:"platformAvailable"`
	TrainServices     []struct {
		AdhocAlerts         interface{} `json:"adhocAlerts"`
		CancelReason        string      `json:"cancelReason"`
		CurrentDestinations interface{} `json:"currentDestinations"`
		CurrentOrigins      interface{} `json:"currentOrigins"`
		DelayReason         interface{} `json:"delayReason"`
		Destination         []struct {
			AssocIsCancelled bool        `json:"assocIsCancelled"`
			Crs              string      `json:"crs"`
			FutureChangeTo   interface{} `json:"futureChangeTo"`
			LocationName     string      `json:"locationName"`
			Via              interface{} `json:"via"`
		} `json:"destination"`
		DetachFront             bool        `json:"detachFront"`
		Eta                     interface{} `json:"eta"`
		Etd                     string      `json:"etd"`
		FilterLocationCancelled bool        `json:"filterLocationCancelled"`
		Formation               interface{} `json:"formation"`
		IsCancelled             bool        `json:"isCancelled"`
		IsCircularRoute         bool        `json:"isCircularRoute"`
		IsReverseFormation      bool        `json:"isReverseFormation"`
		Length                  int         `json:"length"`
		Operator                string      `json:"operator"`
		OperatorCode            string      `json:"operatorCode"`
		Origin                  []struct {
			AssocIsCancelled bool        `json:"assocIsCancelled"`
			Crs              string      `json:"crs"`
			FutureChangeTo   interface{} `json:"futureChangeTo"`
			LocationName     string      `json:"locationName"`
			Via              interface{} `json:"via"`
		} `json:"origin"`
		Platform                interface{} `json:"platform"`
		PreviousCallingPoints   interface{} `json:"previousCallingPoints"`
		Rsid                    interface{} `json:"rsid"`
		ServiceID               string      `json:"serviceID"`
		ServiceIDGUID           string      `json:"serviceIdGuid"`
		ServiceIDPercentEncoded string      `json:"serviceIdPercentEncoded"`
		ServiceIDURLSafe        string      `json:"serviceIdUrlSafe"`
		ServiceType             int         `json:"serviceType"`
		Sta                     string      `json:"sta"`
		Std                     string      `json:"std"`
		SubsequentCallingPoints []struct {
			AssocIsCancelled bool `json:"assocIsCancelled"`
			CallingPoint     []struct {
				AdhocAlerts  interface{} `json:"adhocAlerts"`
				At           interface{} `json:"at"`
				Crs          string      `json:"crs"`
				DetachFront  bool        `json:"detachFront"`
				Et           string      `json:"et"`
				Formation    interface{} `json:"formation"`
				IsCancelled  bool        `json:"isCancelled"`
				Length       int         `json:"length"`
				LocationName string      `json:"locationName"`
				St           string      `json:"st"`
			} `json:"callingPoint"`
			ServiceChangeRequired bool `json:"serviceChangeRequired"`
			ServiceType           int  `json:"serviceType"`
		} `json:"subsequentCallingPoints"`
	} `json:"trainServices"`
}

type AllDepartures struct {
	Departures []struct {
		Service struct {
			Formation interface{} `json:"formation"`
			Origin    []struct {
				LocationName     string      `json:"locationName"`
				Crs              string      `json:"crs"`
				Via              interface{} `json:"via"`
				FutureChangeTo   interface{} `json:"futureChangeTo"`
				AssocIsCancelled bool        `json:"assocIsCancelled"`
			} `json:"origin"`
			Destination []struct {
				LocationName     string      `json:"locationName"`
				Crs              string      `json:"crs"`
				Via              interface{} `json:"via"`
				FutureChangeTo   interface{} `json:"futureChangeTo"`
				AssocIsCancelled bool        `json:"assocIsCancelled"`
			} `json:"destination"`
			CurrentOrigins          interface{} `json:"currentOrigins"`
			CurrentDestinations     interface{} `json:"currentDestinations"`
			Rsid                    interface{} `json:"rsid"`
			ServiceIDPercentEncoded string      `json:"serviceIdPercentEncoded"`
			ServiceIDGUID           string      `json:"serviceIdGuid"`
			ServiceIDURLSafe        string      `json:"serviceIdUrlSafe"`
			Sta                     string      `json:"sta"`
			Eta                     string      `json:"eta"`
			Std                     string      `json:"std"`
			Etd                     string      `json:"etd"`
			Platform                string      `json:"platform"`
			Operator                string      `json:"operator"`
			OperatorCode            string      `json:"operatorCode"`
			IsCircularRoute         bool        `json:"isCircularRoute"`
			IsCancelled             bool        `json:"isCancelled"`
			FilterLocationCancelled bool        `json:"filterLocationCancelled"`
			ServiceType             int         `json:"serviceType"`
			Length                  int         `json:"length"`
			DetachFront             bool        `json:"detachFront"`
			IsReverseFormation      bool        `json:"isReverseFormation"`
			CancelReason            interface{} `json:"cancelReason"`
			DelayReason             interface{} `json:"delayReason"`
			ServiceID               string      `json:"serviceID"`
			AdhocAlerts             interface{} `json:"adhocAlerts"`
		} `json:"service"`
		Crs string `json:"crs"`
	} `json:"departures"`
	GeneratedAt        time.Time   `json:"generatedAt"`
	LocationName       string      `json:"locationName"`
	Crs                string      `json:"crs"`
	FilterLocationName interface{} `json:"filterLocationName"`
	Filtercrs          interface{} `json:"filtercrs"`
	FilterType         int         `json:"filterType"`
	NrccMessages       []struct {
		Value string `json:"value"`
	} `json:"nrccMessages"`
	PlatformAvailable    bool `json:"platformAvailable"`
	AreServicesAvailable bool `json:"areServicesAvailable"`
}

type NextTrain struct {
	Sta string `json:"sta"`
	Eta string `json:"eta"`
}
